﻿var JobPortalApp = JobPortalApp || {};


(function () {
    "use strict";

    jQuery(document).ready(function () {

         //For testing 
         //Object.defineProperty(document, "referrer", { get: function () { return "http://www.bing.com"; } });

        var sourceParameterValue = "";
        var referrer = encodeURIComponent(document.referrer);

        // Check if source parameter already exists
        if (JobPortalApp.GetUrlParameter("source") !== "") {
            var existingSourceParameter = JobPortalApp.GetUrlParameter("source");
            SetSourceParameterCookie(existingSourceParameter);
        } // Check if refferer (use case: bussiness doesn't or can't add source parameter when posting links somewhere)
        else if (referrer !== "" && referrer !== undefined && referrer !== null && Cookies.get("asource") === undefined) {
                MatchAgainstPossibleReferrers(referrer);
        } // Set source as direct hit
        else if (Cookies.get("asource") === undefined) {
            SetSourceParameterCookie("LandingPageDirect");
        }

        // Check if there is an apply button to Avature, add source parameter
        setTimeout(function () {
            if (jQuery(".JQSeachResults").length === 0) {
                jQuery(".lnk-avature,.lnk-button,a.button").each(function () {
                    var href = jQuery(this).attr("href");
                    if (href.indexOf("avature") >= 0) {
                        sourceParameterValue = GetSourceParameterCookie();
                        if (href.indexOf("?") >= 0) {
                            jQuery(this).attr("href", href + "&source=" + sourceParameterValue);
                        } else {
                            jQuery(this).attr("href", href + "?source=" + sourceParameterValue);
                        }
                    }
                });
                if (jQuery(".job-detail-tc-call-to-action a").length) {
                    var applyUrl = jQuery(".job-detail-tc-call-to-action a").attr("href");
                    sourceParameterValue = GetSourceParameterCookie();
                    jQuery(".job-detail-tc-call-to-action a").attr("href", applyUrl + "?source=" + sourceParameterValue);
                }
            }
        }, 1000);

        // Special case test Career Site search page, 
        if (jQuery(".JQSeachResults").length) {
            jQuery(".job-detail").off('DOMSubtreeModified');
            jQuery(".job-detail").bind('DOMSubtreeModified', function () {
                if (jQuery(".job-detail-button-row .submit").length) {
                    var applyUrl = jQuery(".job-detail-button-row .submit").attr("href");
                    if (applyUrl.indexOf("avature") >= 0 && !(applyUrl.includes("source="))) {
                        // avoid recursion
                        sourceParameterValue = GetSourceParameterCookie();
                        jQuery(".job-detail-button-row .submit").attr("href", applyUrl + "&source=" + sourceParameterValue);
                    }
                }
                if (jQuery(".job-detail-tc-call-to-action a").length) {
                    var applyUrl = jQuery(".job-detail-tc-call-to-action a").attr("href");
                    if (!(applyUrl.includes("source="))) { // avoid recursion
                        sourceParameterValue = GetSourceParameterCookie();
                        jQuery(".job-detail-tc-call-to-action a").attr("href", applyUrl + "?source=" + sourceParameterValue);
                    }
                }
            });
        }
    });

    var GetSourceParameterCookie = function () {
        if (Cookies.get("asource") !== undefined) {
            return Cookies.get("asource")
        }
    };
    var SetSourceParameterCookie = function (value) {
        Cookies.set('asource', value, { expires: 30 });
    };

    var MatchAgainstPossibleReferrers = function (referrerUrl) {
        var matchedReferrer = "";
        jQuery.ajax({
            type: "GET",
            url: "/data/avature-sources.xml",
            dataType: "xml",
            success: MatchReferrer
        });

        function MatchReferrer(xml) {
            if (JobPortalApp.CustomerKey) {
                jQuery(xml).find("Customer").each(function () {
                    if (jQuery(this).attr("CustomerKey") === JobPortalApp.CustomerKey) {
                        jQuery(this).find("Source").each(function () {
                            var sourceParameter = jQuery(this).find("Parameter").text();
                            jQuery(this).find("Query").each(function () {
                                var sourceQuery = jQuery(this).text();
                                if (referrerUrl.match(sourceQuery)) {
                                    matchedReferrer = sourceParameter;
                                }
                            })
                        });
                    }

                });
            }
            if (matchedReferrer !== "") {
                SetSourceParameterCookie(matchedReferrer);
            } else {
                SetSourceParameterCookie("LandingPageOtherReferrer");
            }
        }
    }

}).apply(JobPortalApp);